<?php
// by WebMan v.6 (03.07.2014)

if(!defined('VALID_RUN')) { die('ACCESS DENIED'); }

class cmsDebugConfig {

	private static $instance;

  private $data = array();  // Массив с текущей рабочей конфигурацией
                            // $data['debug_on'] - Последнее значение разрешения отладки для вывода сообщения в админке
                            // (устанавливается при загрузке или сохранении конфига)

  //----------------------------------------------------------------------------
  // Дефолтный конфиг
  private $cfg_default = array(
    'debug_admin_only'    => 1,  // bool Показывать отладочную информацию только администраторам

    'debug_on_point'      => 1,  // bool Включить показ контрольных точек
    'debug_on_sql'        => 0,  // bool Включить показ коннектов и запросов к БД
    'debug_on_auto'       => 0,  // bool Включить показ автозагрузок
    'debug_on_include'    => 0,  // bool Включить показ инклудов
    'debug_on_hook'       => 0,  // bool Включить показ хуков
    'debug_on_widget'     => 0,  // bool Включить показ виджетов
    'debug_on_cache'      => 0,  // bool Включить показ обращений к кэшу

    'trace_level_point'   => 3,  // int  Глубина трассировки для контрольных точек
    'trace_level_sql'     => 3,  // int  Глубина трассировки для коннектов и запросов к БД
    'trace_level_auto'    => 3,  // int  Глубина трассировки для автозагрузок
    'trace_level_include' => 3,  // int  Глубина трассировки для инклудов
    'trace_level_hook'    => 3,  // int  Глубина трассировки для хуков
    'trace_level_widget'  => 3,  // int  Глубина трассировки для виджетов
    'trace_level_cache'   => 3,  // int  Глубина трассировки для обращений к кэшу

    'filter_query_sql'      => '',  // string Строка для фильтра SQL-запросов по части строки запроса
    'filter_query_from'     => '',  // string Строка для фильтра SQL-запросов по пути/имени вызывающего файла или класса/функции
    
    'filter_include_file'   => '',  // string Строка для фильтра инклудов по пути/имени подключаемого файла
    'filter_include_from'   => '',  // string Строка для фильтра инклудов по пути/имени подключающего файла или класса/функции

    'filter_hook_event'     => 'none',  // string Строка для фильтра лога хуков по выбранному событию (выпадающий список событий)
    'filter_hook_control'   => 'none',  // string Строка для фильтра лога хуков по выбранному контроллеру (выпадающий список контроллеров)

    'filter_widget_widget'  => 'none',  // string Строка для фильтра лога виджетов по выбранному виджету (выпадающий список виджетов)
    'filter_widget_control' => 'none',  // string Строка для фильтра лога виджетов по выбранному контроллеру (выпадающий список контроллеров)

    'includes_table_error' => 1,      // bool   В таблице количеств инклудов показывать только 2 и более вызовов или ошибки
    'hook_table'           => 'none', // string Режим таблицы хуков
    'hook_log_data'        => 0,      // bool   Выводить в лог данные и результаты хуков
    'widget_log_data'      => 0,      // bool   Выводить в лог данные виджетов
    'widget_table_active'  => 0,      // bool   В таблице виджетов показывать только активные виджеты
    'memory_real_usage'    => 0,      // bool   Показывать полное (блочное) выделение памяти скрипту
    'emulate_lag'          => 0,      // int    Имитировать сетевые задержки (в миллисекундах)
  );

// =============================================================================

  public function __construct($params="") {
    if (is_array($params)) {
      $this->data = array_merge($this->cfg_default, $params);
    } else {
      define("DEBUG_CONFIG",  1); // Устанавливаем признак правильного запроса конфига
      $this->data = require("system/config/debug.php");
    }
    $this->data['debug_on'] = DEBUG_ON;
  }

  // ---------------------------------------------------------------------------

  public static function getInstance($params="") {
    if (self::$instance === null) { self::$instance = new self($params); }
    return self::$instance;
  }

  // ---------------------------------------------------------------------------

  public function set($key, $value){
    $this->data[$key] = $value;
  }

  public function __get($name) {
    return $this->data[$name];
  }

  public static function get($key){
    return self::getInstance()->$key;
  }

  public function getAll(){
    return $this->data;
  }

//==============================================================================

  /**
  * Сохраняет конфигурацию из принятых параметров в файл
  * @param array $params Массив с новой конфигурацией
  * @return int Возвращает количество записанных байт в файл конфига, или FALSE в случае ошибки
  */
  public function save($params){

    $debug_on = DEBUG_ON;
    
    // Выделяем из массива параметров флаг включения отладки (если он там есть)
    if (array_key_exists('debug_on', $params)) {
      $debug_on = $params['debug_on'];
      unset($params['debug_on']);
      $this->data['debug_on'] = $debug_on;
    } else {
      $this->data['debug_on'] = false;
    }
    
    $params = array_merge($this->cfg_default, $params);

    $dump = "<?php\n" .
        "if (!defined(\"DEBUG_ON\")) define(\"DEBUG_ON\", '" . $debug_on . "');\n\n" .
        "if (!DEBUG_ON && !defined(\"DEBUG_CONFIG\")) { return false; }\n\n" . 
        "return array(\n\n";

    foreach($params as $key=>$value){

      if (!is_numeric($value)) { $value = "'{$value}'"; }

      $tabs = 7 - ceil((mb_strlen($key)+3)/4);

      $dump .= "\t'{$key}'";
      $dump .= str_repeat("\t", $tabs);
      $dump .= "=> $value,\n";

    }

    $dump .= "\n);\n?>\n";

    $file = cmsConfig::getInstance()->root_path."system/config/debug.php";

    return @file_put_contents($file, $dump);

  }

//==============================================================================

  /**
  * Возвращает сохранённую конфигурацию из файла конфига
  * Полезна для получения только что изменённых параметров
  * @return array Возвращает сохранённую конфигурацию
  */
  public function getSavedConfig() {
    if (!defined("DEBUG_CONFIG")) define("DEBUG_CONFIG",  1); // Устанавливаем признак правильного запроса конфига
    $data = require("system/config/debug.php");
    $data['debug_on'] = $this->data['debug_on'];
    return $data;
  }

}
