<?php // by WebMan v.6 (03.07.2014) ?>

<h1><?php echo LANG_CP_SECTION_SETTINGS; ?></h1>

<?php

    $this->setPageTitle(LANG_CP_DEBUG);

    $this->addBreadcrumb(LANG_CP_SECTION_SETTINGS, $this->href_to('settings'));
    $this->addBreadcrumb(LANG_CP_DEBUG);

    $this->addMenuItems('settings', $this->controller->getSettingsMenu());

    $this->addToolButton(array(
      'class' => 'help',
      'title' => LANG_HELP,
      'target' => '_blank',
      'href'  => LANG_HELP_URL_SETTINGS_DEBUG
    ));

?>

<div class="pills-menu">
    <?php $this->menu('settings'); ?>
</div>

<?php
    // Подготавливаем блок текущих параметров отладки в "Панели управления"
    $prep_html = "";
    $dbg_config = cmsDebugConfig::getInstance()->getSavedConfig();
    
    if (!$dbg_config['debug_on']) {
        // Отладка отключена
        $prep_html .= LANG_CP_DEBUG_CFG_DEBUG_OFF;
    } else {
        // Отладка включена
        $prep_html .= "<div><span class='error'>".LANG_CP_DEBUG_CFG_DEBUG_ON."</span></div>";

        $prep_html .= "<table>";
        if ($dbg_config['debug_on_point']) {
            $prep_html .= "<tr><td class='point'>- ".LANG_CP_DEBUG_BLOCK_POINT."</td><td class='cfg_params'>( trace = <span class='point'>".$dbg_config['trace_level_point']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_sql']) {
            $prep_html .= "<tr><td class='query'>- ".LANG_CP_DEBUG_BLOCK_SQL."</td><td class='cfg_params'>( ".($dbg_config['filter_query_sql'] ? "filter_sql = '<span class='query'>".$dbg_config['filter_query_sql']."</span>',&ensp;" : "").($dbg_config['filter_query_from'] ? "filter_from = '<span class='query'>".$dbg_config['filter_query_from']."</span>',&ensp;" : "")."trace = <span class='query'>".$dbg_config['trace_level_sql']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_auto']) {
            $prep_html .= "<tr><td class='auto'>- ".LANG_CP_DEBUG_BLOCK_AUTO."</td><td class='cfg_params'>( trace = <span class='auto'>".$dbg_config['trace_level_auto']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_include']) {
            $prep_html .= "<tr><td class='include'>- ".LANG_CP_DEBUG_BLOCK_INCLUDE."</td><td class='cfg_params'>( table = '<span class='include'>".($dbg_config['includes_table_error'] ? "errors_only" : "all")."'</span>,&ensp;".($dbg_config['filter_include_file'] ? "filter_file = '<span class='include'>".$dbg_config['filter_include_file']."</span>',&ensp;" : "").($dbg_config['filter_include_from'] ? "filter_from = '<span class='include'>".$dbg_config['filter_include_from']."</span>',&ensp;" : "")."trace = <span class='include'>".$dbg_config['trace_level_include']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_hook']) {
            $prep_html .= "<tr><td class='hook'>- ".LANG_CP_DEBUG_BLOCK_HOOK."</td><td class='cfg_params'>( ".($dbg_config['hook_log_data'] ? "<span class='hook'>log_hook_data</span>,&ensp;" : "").($dbg_config['hook_table']<>"none" ? "table = '<span class='hook'>".constant("LANG_CP_DEBUG_HOOK_TABLE_".strtoupper($dbg_config['hook_table']))."'</span>,&ensp;" : "").($dbg_config['filter_hook_event']<>"none" ? "filter_widget = '<span class='hook'>".$dbg_config['filter_hook_event']."</span>',&ensp;" : "").($dbg_config['filter_hook_control']<>"none" ? "filter_control = '<span class='hook'>".$dbg_config['filter_hook_control']."</span>',&ensp;" : "")."trace = <span class='hook'>".$dbg_config['trace_level_hook']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_widget']) {
            $prep_html .= "<tr><td class='widget'>- ".LANG_CP_DEBUG_BLOCK_WIDGET."</td><td class='cfg_params'>( ".($dbg_config['widget_log_data'] ? "<span class='widget'>log_widget_data</span>,&ensp;" : "")."table = '<span class='widget'>".($dbg_config['widget_table_active'] ? "active_only" : "all")."'</span>,&ensp;".($dbg_config['filter_widget_widget']<>"none" ? "filter_widget = '<span class='widget'>".$dbg_config['filter_widget_widget']."</span>',&ensp;" : "").($dbg_config['filter_widget_control']<>"none" ? "filter_control = '<span class='widget'>".$dbg_config['filter_widget_control']."</span>',&ensp;" : "")."trace = <span class='widget'>".$dbg_config['trace_level_widget']."</span> )</td></tr>";
        }
        if ($dbg_config['debug_on_cache']) { 
            $prep_html .= "<tr><td class='cache_set'>- ".LANG_CP_DEBUG_BLOCK_CACHE."</td><td class='cfg_params'>( trace = <span class='cache_set'>".$dbg_config['trace_level_cache']."</span> )</td></tr>";
        }
        $prep_html .= "</table>";
        
        $prep_html .= ($dbg_config['debug_admin_only'] ? "<div class=''>".LANG_CP_DEBUG_ADMIN_ONLY."</div>" : "");
        $prep_html .= ($dbg_config['memory_real_usage'] ? "<div class=''>".LANG_CP_DEBUG_MEMORY_REAL_USAGE."</div>" : "");
        $prep_html .= ($dbg_config['emulate_lag']>0 ? "<div class=''>".LANG_CP_DEBUG_EMULATE_LAG." = ".$dbg_config['emulate_lag']."</div>" : "");
    }
?>

<?php
    $this->renderForm($form, $values, array(
        'action' => '',
        'method' => 'post',
        'prepend_html' => "<div id='debug'><fieldset class='cfg'><legend class='cfg_legend'>".LANG_CP_DEBUG_CFG_LEGEND."</legend>".$prep_html."</fieldset></div>"
    ), $errors);
?>
